## gammaray 3.1.0+ds

=== CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2010 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# Pass the following variables to cmake to control the build:
# (See INSTALL.md for more information)
#
# -DQT_VERSION_MAJOR=[5|6]
#  Build against QtX version
#  Default=(The first Qt version found by cmake or the one provided by CMAKE_PREFIX_PATH will be used)
#
# -DGAMMARAY_PROBE_ONLY_BUILD=[true|false]
#  Build only an additional probe configuration for an already existing launcher
#  Default=false
#
# -DGAMMARAY_CLIENT_ONLY_BUILD=[true|false]
#  Build the client part only
#  Default=false
#
# -DGAMMARAY_BUILD_UI=[true|false]
#  Build the GammaRay client and in-process UI
#  Default=true (false for QNX or Android)
#
# -DGAMMARAY_INSTALL_QT_LAYOUT=[true|false]
#  Install into Qt directory layout
#  Default=false
#
# -DGAMMARAY_MULTI_BUILD=[true|false]
#  Build multiple applicable probe configurations
#  Default=true
#
# -DGAMMARAY_BUILD_CLI_INJECTOR=[true|false]
#  Build command line injector on Windows
#  Default=true (ignored on non-Windows systems)
#
# -DGAMMARAY_STATIC_PROBE=[true|false]
#  Build the probe as static library for compile-time injection
#  Default=false
#
# -DGAMMARAY_CORE_ONLY_LAUNCHER=[true|false]
#  Only use QtCore in the CLI launcher (breaks style injector, but is needed for Boot2Qt compatibility
#  Default=false
#
# -DGAMMARAY_DISABLE_FEEDBACK=[true|false]
#  Disable user feedback support
#  Default=false (always true if cross-compiling or building probe-only (see GAMMARAY_PROBE_ONLY_BUILD))
#
# -DGAMMARAY_BUILD_DOCS=[true|false]
#  Build GammaRay documentation
#  Default=true (always false if cross-compiling or building probe-only (see GAMMARAY_PROBE_ONLY_BUILD))
#
# -DGAMMARAY_ENFORCE_QT_ASSERTS=[true|false]
#  Force QT_ASSERT in all builds
#  Default=false
#
# -DGAMMARAY_USE_PCH=[true|false]
#  Enable Precompiled Headers support
#  Default=false
#
# -DGAMMARAY_WITH_KDSME=[true|false]
#  Enable State Machine Viewer Plugin UI by requiring KDAB State Machine Editor
#  Default=false
#
# -DENABLE_GOLD_LINKER=[true|false]
#  Use GNU gold linker
#  Default=false
#
# -DWARNINGS_ARE_ERRORS=[true|false]
#  Enables -Werror
#  Default = false
#

cmake_minimum_required(VERSION 3.16.0)

project(
    GammaRay
    VERSION 3.1.0
    LANGUAGES CXX C
)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ECM/find-modules)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ECM/modules)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/KDAB/modules)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(CMAKE_AUTOMOC TRUE)
set(CMAKE_AUTOUIC TRUE)
set(CMAKE_AUTORCC TRUE)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

if(NOT DEFINED CMAKE_SKIP_BUILD_RPATH)
    set(CMAKE_SKIP_BUILD_RPATH ON)
endif()
if(NOT DEFINED CMAKE_BUILD_WITH_INSTALL_RPATH)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()
if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
if(NOT DEFINED CMAKE_MACOSX_RPATH)
    set(CMAKE_MACOSX_RPATH TRUE)
endif()

# Set a default build type if none was specified
set(default_build_type "Release")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(default_build_type "Debug")
endif()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to ${default_build_type} as none was specified.")
    set(CMAKE_BUILD_TYPE
        "${default_build_type}"
        CACHE STRING "Choose the type of build." FORCE
    )
    # Set the possible values of build type for cmake-gui
    set_property(
        CACHE CMAKE_BUILD_TYPE
        PROPERTY STRINGS
                 "Debug"
                 "Release"
                 "MinSizeRel"
                 "RelWithDebInfo"
    )
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSymbolExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(CTest)
include(GammaRayMacros)
include(GammaRayMacrosInternal)
include(FeatureSummary)
set(KDE_INSTALL_USE_QT_SYS_PATHS OFF)
include(ECMGeneratePriFile)
include(ECMEnableSanitizers)
include(GenerateExportHeader)
include("3rdparty/backward-cpp/BackwardConfig.cmake")

# Exit for blacklisted compilers (those that don't support full C++11)
#  MSVC++ < 2015 aka 1900
#  Clang 3.1
set(BAD_CXX_MESSAGE "")
if(MSVC)
    if(MSVC_VERSION LESS 1900)
        set(BAD_CXX_MESSAGE "MSVC 2015 or higher")
    endif()
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.1.0)
        set(BAD_CXX_MESSAGE "Clang v3.1.0 or higher")
    endif()
endif()
if(BAD_CXX_MESSAGE)
    message(FATAL_ERROR "\nSorry, ${BAD_CXX_MESSAGE} is required to build this software. "
                        "Please retry using a compiler that supports C++11."
    )
endif()

set(GAMMARAY_REQUIRED_CXX_FEATURES
    cxx_lambdas
    cxx_nullptr
    cxx_range_for
    cxx_raw_string_literals
    cxx_uniform_initialization
    cxx_variadic_templates
    cxx_rvalue_references
    cxx_defaulted_functions
    cxx_deleted_functions
    cxx_override
    cxx_final
    cxx_nonstatic_member_init
)

# Version setup
set(GAMMARAY_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(GAMMARAY_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(GAMMARAY_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(GAMMARAY_VERSION ${PROJECT_VERSION})
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
set(GAMMARAY_SOVERSION "3.1.0")
set(GAMMARAY_PLUGIN_VERSION "3.1")
set(PROJECT_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
if(ANDROID)
    # non-rooted Android doesn't like .so versions and requires the lib prefix
    set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES PREFIX "lib")
else()
    set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES SOVERSION ${GAMMARAY_SOVERSION} VERSION ${GAMMARAY_SOVERSION})
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    find_package(Git)
    set_package_properties(
        Git PROPERTIES
        TYPE OPTIONAL
        PURPOSE "Determine exact build version."
    )
    if(GIT_FOUND)
        execute_process(
            COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE _git_revision
        )
        string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
        set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
    endif()
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

message(STATUS "Building GammaRay ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")

#
# Build options
#
set(GAMMARAY_BUILD_UI_DEFAULT ON)
if(QNXNTO OR ANDROID)
    set(GAMMARAY_BUILD_UI_DEFAULT OFF)
endif()

gammaray_option(
    GAMMARAY_PROBE_ONLY_BUILD "Build only an additional probe configuration for an already existing launcher." OFF
)

gammaray_option(GAMMARAY_CLIENT_ONLY_BUILD "Build the client part only." OFF)

if(GAMMARAY_CLIENT_ONLY_BUILD)
    set(GAMMARAY_BUILD_UI_DEFAULT ON)
endif()

if(GAMMARAY_PROBE_ONLY_BUILD)
    set(GAMMARAY_BUILD_UI_DEFAULT OFF)
endif()

gammaray_option(GAMMARAY_BUILD_UI "Build the GammaRay client and in-process UI." ${GAMMARAY_BUILD_UI_DEFAULT})

if(GAMMARAY_PROBE_ONLY_BUILD AND GAMMARAY_CLIENT_ONLY_BUILD)
    message(FATAL_ERROR "You can only use one of the *ONLY* option.")
endif()

gammaray_option(GAMMARAY_INSTALL_QT_LAYOUT "Install into Qt directory layout." OFF)
gammaray_option(GAMMARAY_MULTI_BUILD "Build multiple applicable probe configurations." ON)
gammaray_option(GAMMARAY_BUILD_CLI_INJECTOR "Build command line injector on Windows." ON)
gammaray_option(GAMMARAY_WITH_KDSME "Enable State Machine UI with KDSME" OFF)

set(GAMMARAY_BUILD_DOCS_DEFAULT ON)
set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT OFF)
if(GAMMARAY_PROBE_ONLY_BUILD OR CMAKE_CROSSCOMPILING)
    set(GAMMARAY_BUILD_DOCS_DEFAULT OFF)
    set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT ON)
endif()
gammaray_option(GAMMARAY_BUILD_DOCS "Build GammaRay documentation." ${GAMMARAY_BUILD_DOCS_DEFAULT})
gammaray_option(GAMMARAY_STATIC_PROBE "Build the probe as static library for compile-time injection." OFF)

gammaray_option(GAMMARAY_ENFORCE_QT_ASSERTS "Force QT_ASSERT in all builds." OFF)

gammaray_option(GAMMARAY_DISABLE_FEEDBACK "Disable user feedback support." ${GAMMARAY_DISABLE_FEEDBACK_DEFAULT})

gammaray_option(WARNINGS_ARE_ERRORS "Enables -Werror" OFF)

#
# Static probe setup
#
if(GAMMARAY_STATIC_PROBE)
    set(GAMMARAY_BUILD_UI OFF)
    set(GAMMARAY_PROBE_ONLY_BUILD ON)

    set(GAMMARAY_LIBRARY_TYPE STATIC)
    set(GAMMARAY_PLUGIN_TYPE STATIC)
else()
    set(GAMMARAY_LIBRARY_TYPE SHARED)
    set(GAMMARAY_PLUGIN_TYPE MODULE)
endif()

gammaray_option(GAMMARAY_USE_PCH "Enable Precompiled Headers support" OFF)
if(GAMMARAY_USE_PCH)
    add_library(gammaray_pch_core_gui STATIC)
    file(
        GENERATE
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/empty_pch.cpp
        CONTENT "/*dummy pch file*/"
    )
    target_sources(gammaray_pch_core_gui PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/empty_pch.cpp)
    target_link_libraries(gammaray_pch_core_gui PRIVATE Qt::Core Qt::Gui)
    set_target_properties(
        gammaray_pch_core_gui
        PROPERTIES PRECOMPILE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/core/pch.h
                   CXX_VISIBILITY_PRESET hidden
                   VISIBILITY_INLINES_HIDDEN ON
                   POSITION_INDEPENDENT_CODE ON
    )
endif()

#
# Compiler & linker settings
#
function(append_if condition value)
    if(${condition})
        foreach(variable ${ARGN})
            set(${variable}
                "${${variable}} ${value}"
                PARENT_SCOPE
            )
        endforeach()
    endif()
endfunction()

# Add a C or C++ compiler flag if the compiler supports that flag
macro(add_flag_if_supported flag name)
    check_c_compiler_flag("-Werror ${flag}" "C_SUPPORTS_${name}")
    append_if("C_SUPPORTS_${name}" "${flag}" CMAKE_C_FLAGS)
    check_cxx_compiler_flag("-Werror ${flag}" "CXX_SUPPORTS_${name}")
    append_if("CXX_SUPPORTS_${name}" "${flag}" CMAKE_CXX_FLAGS)
endmacro()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_flag_if_supported(-Wunused-but-set-variable UNUSED_BUT_SET)
    add_flag_if_supported(-Wlogical-op LOGICAL_OP)
    add_flag_if_supported(-Wsizeof-pointer-memaccess POINTER_MEMACCESS)
    add_flag_if_supported(-Wreorder REORDER)
    add_flag_if_supported(-Wformat-security FORMAT_SECURITY)
    add_flag_if_supported(-Wsuggest-override SUGGEST_OVERRIDE)

    check_cxx_compiler_flag(-std=gnu++0x HAVE_GXX_GNUXX11)
    check_cxx_compiler_flag(-std=c++0x HAVE_GXX_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Woverloaded-virtual -Winit-self")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-include-dirs -Wunused -Wundef -Wpointer-arith")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wmissing-noreturn -Werror=return-type -Wswitch")
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        # -Wgnu-zero-variadic-macro-arguments (part of -pedantic) is triggered by every qCDebug()
        # call and therefore results in a lot of noise. This warning is only notifying us that clang
        # is emulating the GCC behaviour instead of the exact standard wording so we can safely ignore it
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu-zero-variadic-macro-arguments")
    endif()
    if(HAVE_GXX_GNUXX11) # QNX needs gnu++0x rather than c++0x for compiling QML V4 private headers

=== 3rdparty/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2024 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

if(GAMMARAY_WITH_KDSME)
    function(add_ksme_subdirectory)
        # Function creates extra scope to keep these variables local
        set(BUILD_DOCS OFF)
        set(BUILD_EXAMPLES OFF)
        set(BUILD_TESTS OFF)

        set(KDSME_PACKAGE_NAME KDSME)
        if(QT_VERSION_MAJOR GREATER_EQUAL 6)
            set(KDSME_PACKAGE_NAME KDSME-qt6)
            set(BUILD_QT6 ON)
        endif()
        set_package_properties(
            ${KDSME_PACKAGE_NAME} PROPERTIES
            URL "https://github.com/KDAB/KDStateMachineEditor"
            DESCRIPTION "KDAB State Machine Editor framework"
            TYPE RECOMMENDED
            PURPOSE "Graphical state machine debugging."
        )

        gammaray_ensure_submodule_exists(KDStateMachineEditor)
        # remove this as it clashes with Gammaray's DQT_DISABLE_DEPRECATED_BEFORE
        remove_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050500)
        add_subdirectory(KDStateMachineEditor)
    endfunction()
    add_ksme_subdirectory()
endif()

add_subdirectory(kde)

=== docs/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2014 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# qdoc toolchain
find_package(Qt${QT_VERSION_MAJOR} NO_MODULE QUIET OPTIONAL_COMPONENTS Help)
if(${QT_VERSION_MAJOR} EQUAL 5)
    find_package(Qt${QT_VERSION_MAJOR} NO_MODULE QUIET OPTIONAL_COMPONENTS AttributionsScannerTools)
elseif(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    find_package(Qt${QT_VERSION_MAJOR} NO_MODULE QUIET OPTIONAL_COMPONENTS ToolsTools)
endif()

if(TARGET Qt::qdoc)
    set(QDOC_EXECUTABLE "$<TARGET_FILE:Qt::qdoc>")
else()
    find_program(QDOC_EXECUTABLE qdoc HINTS ${QT_INSTALL_BINS})
endif()

if(TARGET Qt::qhelpgenerator)
    # Required for Doxygen
    get_target_property(QHELPGEN_EXECUTABLE Qt::qhelpgenerator IMPORTED_LOCATION)
else()
    find_program(QHELPGEN_EXECUTABLE qhelpgenerator HINTS ${QT_INSTALL_BINS} ${QT_INSTALL_LIBEXECS})
endif()

if(TARGET Qt::qtattributionsscanner)
    set(QTATTRIBUTIONSSCANNER_EXECUTABLE Qt::qtattributionsscanner)
else()
    find_program(QTATTRIBUTIONSSCANNER_EXECUTABLE qtattributionsscanner HINTS ${QT_INSTALL_BINS} ${QT_INSTALL_LIBEXECS})
endif()

if(NOT DEFINED QDOC_TEMPLATE_DIR)
    # compute the qdoc template dir from where qt-html-templates-offline.qdocconf is found
    find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf HINTS ${QT_INSTALL_DOCS} ${QT_INSTALL_DATA}
                                                                            ${QT_INSTALL_DATA}/doc
    )
    if(QDOC_TEMPLATE)
        get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE} DIRECTORY)
        get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE_DIR} DIRECTORY)
    endif()
endif()

if(NOT DEFINED QDOC_INDEX_DIR)
    # try to compute the qdoc index dir from where qtcore.index is found
    find_file(QDOC_INDEX qtcore.index HINTS ${QT_INSTALL_DOCS}/qtcore ${QT_INSTALL_DATA}/doc/qtcore)
    if(QDOC_INDEX)
        get_filename_component(QDOC_INDEX_DIR ${QDOC_INDEX} DIRECTORY)
        get_filename_component(QDOC_INDEX_DIR ${QDOC_INDEX_DIR} DIRECTORY)
    endif()
endif()

if(NOT QDOC_EXECUTABLE
   OR NOT QHELPGEN_EXECUTABLE
   OR NOT QDOC_TEMPLATE_DIR
   OR NOT QTATTRIBUTIONSSCANNER_EXECUTABLE
)
    # Expand imported target data for status reporting
    if(TARGET Qt::qdoc)
        get_target_property(QDOC_EXECUTABLE Qt::qdoc IMPORTED_LOCATION)
    endif()
    if(TARGET Qt::qtattributionsscanner)
        get_target_property(QTATTRIBUTIONSSCANNER_EXECUTABLE Qt::qtattributionsscanner IMPORTED_LOCATION)
    endif()
    foreach(_var QDOC_INDEX QDOC_TEMPLATE)
        if(NOT DEFINED ${_var})
            set(${_var} "${_var}_DIR=${${_var}_DIR}")
        endif()
    endforeach()

    message(STATUS "Unable to build user manual in qch format.")
    message(STATUS "qdoc executable: ${QDOC_EXECUTABLE}")
    message(STATUS "qhelpgenerator executable: ${QHELPGEN_EXECUTABLE}")
    message(STATUS "qtattributionsscanner executable: ${QTATTRIBUTIONSSCANNER_EXECUTABLE}")
    message(STATUS "qdoc template: ${QDOC_TEMPLATE}")
    message(STATUS "qdoc index: ${QDOC_INDEX}")
    set(GAMMARAY_USER_MANUAL_BUILD False)
else()
    set(GAMMARAY_USER_MANUAL_BUILD True)
    if(NOT QDOC_INDEX_DIR)
        message(STATUS "Couldn't find index dir, manual won't link to system documentation")
    endif()
endif()

add_feature_info(
    "User Manual creation in qch format" GAMMARAY_USER_MANUAL_BUILD
    "Requires qdoc, qhelpgenerator, qtattributionsscanner, the qdoc templates and index files"
)

# Doxygen
find_package(Doxygen)
set_package_properties(
    Doxygen PROPERTIES
    TYPE OPTIONAL
    DESCRIPTION "API Documentation system"
    URL "https://www.doxygen.org"
    PURPOSE "Needed to build the API documentation."
)
if(DOXYGEN_DOT_EXECUTABLE)
    set(HAVE_DOT "YES")
else()
    set(HAVE_DOT "NO")
    message(STATUS "Unable to provide inheritance diagrams for the API documentation. "
                   "To fix, install the graphviz project from https://www.graphviz.org"
    )
endif()

if(DOXYGEN_FOUND AND QHELPGEN_EXECUTABLE)
    set(GAMMARAY_API_DOCS_BUILD True)
else()
    set(GAMMARAY_API_DOCS_BUILD False)
endif()

#
# generate docs
#

if(GAMMARAY_API_DOCS_BUILD)
    add_subdirectory(api)
endif()
if(GAMMARAY_USER_MANUAL_BUILD)
    add_subdirectory(manual)
    add_subdirectory(collection)
endif()
add_subdirectory(man)

=== plugins/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

if(${QT_VERSION_MAJOR} EQUAL 5 AND TARGET Qt5::Core)
    add_subdirectory(codecbrowser)
endif()
if((${QT_VERSION_MAJOR} EQUAL 5) OR (${QT_VERSION_MAJOR} EQUAL 6 AND TARGET Qt6::StateMachine))
    add_subdirectory(statemachineviewer)
else()
    message(STATUS "WARNING: Skipping the statemachineviewer plugin since Qt6StateMachine was not found")
endif()
add_subdirectory(eventmonitor)
add_subdirectory(fontbrowser)
add_subdirectory(kjobtracker)
add_subdirectory(localeinspector)
add_subdirectory(modelinspector)
add_subdirectory(quickinspector)
add_subdirectory(signalmonitor)
add_subdirectory(timertop)

add_subdirectory(mimetypes)
add_subdirectory(network)
add_subdirectory(sysinfo)
add_subdirectory(translatorinspector)
add_subdirectory(webinspector)
add_subdirectory(wlcompositorinspector)

if(TARGET Qt::Gui)
    add_subdirectory(guisupport)
    add_subdirectory(textdocumentinspector)
endif()
if((${QT_VERSION_MAJOR} EQUAL 5 AND TARGET Qt5::Gui) OR (${QT_VERSION_MAJOR} EQUAL 6 AND TARGET Qt6::OpenGL))
    add_subdirectory(openglsupport)
endif()

if(TARGET Qt::Widgets)
    add_subdirectory(actioninspector)
    add_subdirectory(widgetinspector)
    add_subdirectory(sceneinspector)
    add_subdirectory(styleinspector)
endif()

# just checking whether Qt5::ScriptTools is found should be enough, but it isn't.
# thus check both that Qt5::Script & Qt5::ScriptTools are found to fix https://github.com/KDAB/GammaRay/issues/492
if((Qt5Script_FOUND AND Qt5ScriptTools_FOUND) OR (Qt5Script_FOUND AND Qt5ScriptTools_FOUND))
    add_subdirectory(scriptenginedebugger)
endif()

if(TARGET Qt::Qml)
    add_subdirectory(qmlsupport)
endif()

if(TARGET Qt::QuickWidgets)
    add_subdirectory(quickwidgetsupport)
endif()

if(TARGET Qt::Bluetooth)
    add_subdirectory(bluetooth)
endif()

if(TARGET Qt::Positioning)
    add_subdirectory(positioning)
endif()

if(TARGET Qt::3DRender AND TARGET Qt::3DExtras)
    add_subdirectory(qt3dinspector)
endif()

=== tests/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2011 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# keep test output locally, in the multibuild case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR})

configure_file(gammaray-test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/gammaray-test-config.h)

# create intermediate modeltestobj object files which unit tests can use
add_library(
    modeltestobj OBJECT
)

# create intermediate test_helpers_obj object files which unit tests can use
add_library(
    test_helpers_obj OBJECT
    testhelpers.cpp
)
set_target_properties(test_helpers_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(test_helpers_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(
    test_helpers_obj PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                             $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(
    test_helpers_obj
    PUBLIC $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
           $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    # create intermediate base_probe_test_obj object files which unit tests can use
    add_library(base_probe_test_obj OBJECT baseprobetest.h)
    set_target_properties(base_probe_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
    target_compile_features(base_probe_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
    target_include_directories(
        base_probe_test_obj PUBLIC $<TARGET_PROPERTY:gammaray_core,INTERFACE_INCLUDE_DIRECTORIES>
                                   $<TARGET_PROPERTY:gammaray_common,INTERFACE_INCLUDE_DIRECTORIES>
    )
    target_compile_definitions(
        base_probe_test_obj PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                                    $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
    ) # for -DQT_NAMESPACE=...
    target_include_directories(
        base_probe_test_obj PUBLIC $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
                                   $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_INCLUDE_DIRECTORIES>
    )

    if(TARGET Qt::Quick)
        # create intermediate base_quick_test_obj object files which unit tests can use
        add_library(base_quick_test_obj OBJECT basequicktest.h)
        set_target_properties(base_quick_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
        target_compile_features(base_quick_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
        target_compile_definitions(
            base_quick_test_obj
            PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                    $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
                    $<TARGET_PROPERTY:Qt${QtQuick_VERSION_MAJOR}::Quick,INTERFACE_COMPILE_DEFINITIONS>
        ) # for -DQT_NAMESPACE=...
        target_include_directories(
            base_quick_test_obj PUBLIC $<TARGET_PROPERTY:base_probe_test_obj,INTERFACE_INCLUDE_DIRECTORIES>
        )
        target_include_directories(
            base_quick_test_obj
            PUBLIC $<TARGET_PROPERTY:Qt${QtQuick_VERSION_MAJOR}::Quick,INTERFACE_INCLUDE_DIRECTORIES>
        )
    endif()
endif()

add_subdirectory(shared)
add_subdirectory(manual)
add_subdirectory(targets)

# plain unit tests
function(gammaray_add_test _name)
    add_executable(${_name} ${ARGN} $<TARGET_OBJECTS:test_helpers_obj>)
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring probe injection
function(gammaray_add_probe_test _name)
    add_executable(
        ${_name} ${ARGN} $<TARGET_OBJECTS:gammaray_probe_obj> $<TARGET_OBJECTS:test_helpers_obj>
                 $<TARGET_OBJECTS:base_probe_test_obj>
    )
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring quick and probe injection
function(gammaray_add_quick_test _name)
    add_executable(
        ${_name}
        ${ARGN}
        $<TARGET_OBJECTS:gammaray_probe_obj>
        $<TARGET_OBJECTS:test_helpers_obj>
        $<TARGET_OBJECTS:base_probe_test_obj>
        $<TARGET_OBJECTS:base_quick_test_obj>
    )
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

### BENCH SUITE

if(TARGET Qt::Widgets)
    add_executable(benchsuite benchsuite.cpp)
    gammaray_set_rpath(benchsuite ${BIN_INSTALL_DIR})

    target_link_libraries(
        benchsuite
        Qt::Core
        Qt::Gui
        Qt::Widgets
        Qt::Test
        gammaray_common
        gammaray_core
    )

    #
    # Full-scale injection tests
    #
    add_executable(connectiontest test_connections.cpp)
    gammaray_set_rpath(connectiontest ${BIN_INSTALL_DIR})

    target_link_libraries(
        connectiontest
        Qt::Core
        Qt::Gui
        Qt::Widgets
        Qt::Test
    )

endif()

add_executable(
    attachhelper
    attachhelper.cpp attachhelper.h
)
gammaray_set_rpath(attachhelper ${BIN_INSTALL_DIR})

target_link_libraries(
    attachhelper Qt::Core
)

if(UNIX)
    find_program(GDB_EXECUTABLE gdb)
    find_program(LLDB_EXECUTABLE lldb)
endif()

set(INJECTOR_TYPES)
if(UNIX)
    list(APPEND INJECTOR_TYPES preload style)

    if(GDB_EXECUTABLE)
        list(APPEND INJECTOR_TYPES gdb)
    endif()
    if(LLDB_EXECUTABLE)
        list(APPEND INJECTOR_TYPES lldb)
    endif()
elseif(WIN32)
    list(APPEND INJECTOR_TYPES windll style)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    # No probes are available in client only build
    foreach(injectorType ${INJECTOR_TYPES})
        add_test(
            connectiontest-${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray
            --inprocess
            --listen
            tcp://127.0.0.1
            -unittest
            -i
            ${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
        )
        add_test(
            connectiontest-${injectorType}-filter
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray
            --inprocess
            -unittest
            --listen
            tcp://127.0.0.1
            -filtertest
            -i
            ${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
        )
        set_tests_properties(connectiontest-${injectorType}-filter PROPERTIES ENVIRONMENT GAMMARAY_TEST_FILTER=1)
    endforeach()
endif()

#
# common and core unit tests
#
gammaray_add_test(multisignalmappertest multisignalmappertest.cpp ../core/multisignalmapper.cpp)
target_link_libraries(
    multisignalmappertest Qt::Gui
)

gammaray_add_test(sourcelocationtest sourcelocationtest.cpp)
target_link_libraries(
    sourcelocationtest Qt::Gui gammaray_common
)

gammaray_add_test(selflocatortest selflocatortest.cpp)
target_link_libraries(
    selflocatortest Qt::Gui gammaray_common ${CMAKE_DL_LIBS}
)

gammaray_add_test(executiontest executiontest.cpp)
target_link_libraries(
    executiontest Qt::Gui gammaray_core
)

gammaray_add_test(metaobjecttest metaobjecttest.cpp)
target_link_libraries(
    metaobjecttest Qt::CorePrivate gammaray_core
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(problemreportertest problemreportertest.cpp $<TARGET_OBJECTS:modeltestobj>)
    target_link_libraries(problemreportertest gammaray_core)
    if(TARGET Qt::Qml)
        target_link_libraries(problemreportertest Qt::Qml)
    endif()
    if(TARGET Qt::Widgets)
        target_link_libraries(problemreportertest Qt::Widgets)
    endif()
endif()

gammaray_add_test(objectinstancetest objectinstancetest.cpp)
target_link_libraries(
    objectinstancetest gammaray_core
)

gammaray_add_test(propertysyncertest propertysyncertest.cpp)
target_link_libraries(
    propertysyncertest gammaray_common Qt::Gui
)

gammaray_add_test(propertyadaptortest propertyadaptortest.cpp)
target_link_libraries(
    propertyadaptortest
    gammaray_core
    Qt::Gui
    Qt::CorePrivate
    gammaray_shared_test_data
)

if(HAVE_QT_WIDGETS)
    gammaray_add_test(enumpropertytest enumpropertytest.cpp)
    target_link_libraries(enumpropertytest gammaray_core Qt::Gui Qt::Widgets)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(propertymodeltest propertymodeltest.cpp $<TARGET_OBJECTS:modeltestobj>)
    target_link_libraries(propertymodeltest gammaray_core gammaray_shared_test_data)
endif()

gammaray_add_test(qmetaobjectvalidatortest qmetaobjectvalidatortest.cpp)
target_link_libraries(
    qmetaobjectvalidatortest Qt::Gui Qt::CorePrivate gammaray_core
)

if(GAMMARAY_BUILD_UI)
    gammaray_add_test(
        metatypemodeltest
        metatypemodeltest.cpp
        ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
        ${CMAKE_SOURCE_DIR}/core/tools/metatypebrowser/metatypesmodel.cpp
        ${CMAKE_SOURCE_DIR}/ui/tools/metatypebrowser/metatypesclientmodel.cpp
        $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(
        metatypemodeltest
        gammaray_core
        Qt::Gui
        Qt::Widgets
        Qt::CorePrivate
    )
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(signalspycallbacktest signalspycallbacktest.cpp)
    target_link_libraries(signalspycallbacktest gammaray_core)
    gammaray_add_probe_test(integrationtest integrationtest.cpp)
    target_link_libraries(integrationtest gammaray_core)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(multithreadingtest multithreadingtest.cpp)
    target_link_libraries(multithreadingtest gammaray_core)

    if(GAMMARAY_BUILD_UI)
        gammaray_add_probe_test(
            methodmodeltest
            methodmodeltest.cpp
            ${CMAKE_SOURCE_DIR}/core/objectmethodmodel.cpp
            ${CMAKE_SOURCE_DIR}/core/qmetaobjectvalidator.cpp
            ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
            ${CMAKE_SOURCE_DIR}/ui/tools/objectinspector/clientmethodmodel.cpp
            $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(
            methodmodeltest
            gammaray_core
            Qt::Gui
            Qt::Widgets
            Qt::CorePrivate
        )
    endif()
endif()

#
# ui unit tests
#
if(GAMMARAY_BUILD_UI)
    gammaray_add_test(propertybindertest propertybindertest.cpp)
    target_link_libraries(propertybindertest gammaray_ui)

    if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
        gammaray_add_probe_test(
            metaobjecttreemodeltest metaobjecttreemodeltest.cpp
            ${CMAKE_SOURCE_DIR}/ui/tools/metaobjectbrowser/metaobjecttreeclientproxymodel.cpp
            $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(metaobjecttreemodeltest gammaray_core gammaray_ui Qt::Gui)

        gammaray_add_probe_test(
            toolmanagertest toolmanagertest.cpp ../common/toolmanagerinterface.cpp $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(toolmanagertest gammaray_core gammaray_ui Qt::Network)
    endif()
endif()

#
# launcher unit tests
#
add_executable(
    sleep
    sleep.cpp
)
target_link_libraries(
    sleep Qt::Core
)

=== plugins/codecbrowser/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2013 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe part
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_codecbrowser_plugin_srcs codecbrowser.cpp codecmodel.cpp)

    gammaray_add_plugin(
        gammaray_codecbrowser_plugin
        JSON
        gammaray_codecbrowser.json
        SOURCES
        ${gammaray_codecbrowser_plugin_srcs}
    )
    set_target_properties(gammaray_codecbrowser_plugin PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)

    target_link_libraries(gammaray_codecbrowser_plugin gammaray_core)
endif()

# ui part
if(GAMMARAY_BUILD_UI)

    set(gammaray_codecbrowser_plugin_ui_srcs codecbrowserwidget.cpp)

    gammaray_add_plugin(
        gammaray_codecbrowser_ui_plugin
        JSON
        gammaray_codecbrowser.json
        SOURCES
        ${gammaray_codecbrowser_plugin_ui_srcs}
    )

    target_link_libraries(gammaray_codecbrowser_ui_plugin gammaray_common gammaray_ui)

endif()

=== plugins/fontbrowser/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2013 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe part
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_fontbrowser_plugin_srcs
        fontbrowser.cpp
        fontbrowser.h
        fontbrowserinterface.cpp
        fontbrowserinterface.h
        fontbrowserserver.cpp
        fontbrowserserver.h
        fontdatabasemodel.cpp
        fontdatabasemodel.h
        fontmodel.cpp
        fontmodel.h
    )

    gammaray_add_plugin(
        gammaray_fontbrowser_plugin
        JSON
        gammaray_fontbrowser.json
        SOURCES
        ${gammaray_fontbrowser_plugin_srcs}
    )

    target_link_libraries(gammaray_fontbrowser_plugin gammaray_core)
    target_link_libraries(gammaray_fontbrowser_plugin Qt::Gui)
endif()

# ui part
if(GAMMARAY_BUILD_UI)

    set(gammaray_fontbrowser_plugin_ui_srcs
        fontbrowserclient.cpp
        fontbrowserclient.h
        fontbrowserinterface.cpp
        fontbrowserinterface.h
        fontbrowserwidget.cpp
        fontbrowserwidget.h
    )

    gammaray_add_plugin(
        gammaray_fontbrowser_ui_plugin
        JSON
        gammaray_fontbrowser.json
        SOURCES
        ${gammaray_fontbrowser_plugin_ui_srcs}
    )

    target_link_libraries(gammaray_fontbrowser_ui_plugin gammaray_common gammaray_ui)

endif()

=== plugins/network/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2016 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe plugin
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_network_srcs
        cookies/cookieextension.cpp
        cookies/cookieextension.h
        cookies/cookiejarmodel.cpp
        cookies/cookiejarmodel.h
        networkinterfacemodel.cpp
        networkinterfacemodel.h
        networkreplymodel.cpp
        networkreplymodel.h
        networksupport.cpp
        networksupport.h
        networksupportinterface.cpp
        networksupportinterface.h
    )
    if(${QT_VERSION_MAJOR} EQUAL 5 AND TARGET Qt5::Network)
        list(APPEND gammaray_network_srcs networkconfigurationmodel.cpp networkconfigurationmodel.h)
    endif()
    gammaray_add_plugin(
        gammaray_network
        JSON
        gammaray_network.json
        SOURCES
        ${gammaray_network_srcs}
    )
    target_link_libraries(gammaray_network gammaray_core Qt::Network Qt::CorePrivate)
    set_target_properties(gammaray_network PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)
endif()

# ui plugin
if(GAMMARAY_BUILD_UI)
    set(gammaray_network_ui_srcs
        clientnetworkconfigurationmodel.cpp
        clientnetworkconfigurationmodel.h
        clientnetworkreplymodel.cpp
        clientnetworkreplymodel.h
        cookies/cookietab.cpp
        cookies/cookietab.h
        networkconfigurationwidget.cpp
        networkconfigurationwidget.h
        networkinterfacewidget.cpp
        networkinterfacewidget.h
        networkreplywidget.cpp
        networkreplywidget.h
        networksupportclient.cpp
        networksupportclient.h
        networksupportinterface.cpp
        networksupportinterface.h
        networkwidget.cpp
        networkwidget.h
    )
    gammaray_add_plugin(
        gammaray_network_ui
        JSON
        gammaray_network.json
        SOURCES
        ${gammaray_network_ui_srcs}
    )
    target_link_libraries(gammaray_network_ui gammaray_ui Qt::Network)
endif()

=== plugins/quickinspector/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2014 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

if(NOT TARGET Qt::Quick)
    # We can't do anything here
    return()
endif()

# shared stuff
set(gammaray_quickinspector_shared_srcs quickinspectorinterface.cpp quickitemgeometry.cpp quickdecorationsdrawer.cpp
                                        materialextension/materialextensioninterface.cpp
)

add_library(
    gammaray_quickinspector_shared STATIC
    ${gammaray_quickinspector_shared_srcs}
)
target_link_libraries(
    gammaray_quickinspector_shared gammaray_common Qt::Gui Qt::Quick
)

set_target_properties(gammaray_quickinspector_shared PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(gammaray_quickinspector_shared PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_quickinspector_srcs
        quickanchorspropertyadaptor.cpp
        quickanchorspropertyadaptor.h
        quickinspector.cpp
        quickinspector.h
        quickitemmodel.cpp
        quickitemmodel.h
        quickpaintanalyzerextension.cpp
        quickpaintanalyzerextension.h
        quickscenegraphmodel.cpp
        quickscenegraphmodel.h
        quickscreengrabber.cpp
        quickscreengrabber.h
    )

    if(NOT QT_NO_OPENGL)
        list(
            APPEND
            gammaray_quickinspector_srcs
            geometryextension/sggeometryextension.cpp
            geometryextension/sggeometryextension.h
            geometryextension/sggeometrymodel.cpp
            geometryextension/sggeometrymodel.h
            materialextension/materialextension.cpp
            materialextension/materialextension.h
            materialextension/materialshadermodel.cpp
            materialextension/materialshadermodel.h
            materialextension/qquickopenglshadereffectmaterialadaptor.cpp
            materialextension/qquickopenglshadereffectmaterialadaptor.h
            textureextension/qsgtexturegrabber.cpp
            textureextension/qsgtexturegrabber.h
            textureextension/textureextension.cpp
            textureextension/textureextension.h
        )
    endif()

    gammaray_add_plugin(
        gammaray_quickinspector
        JSON
        gammaray_quickinspector.json
        SOURCES
        ${gammaray_quickinspector_srcs}
    )

    if(TARGET Qt${QT_VERSION_MAJOR}::Quick)
        target_sources(
            gammaray_quickinspector PUBLIC ${CMAKE_CURRENT_LIST_DIR}/quickimplicitbindingdependencyprovider.cpp
        )
    endif()

    target_link_libraries(
        gammaray_quickinspector
        gammaray_quickinspector_shared
        gammaray_core
        Qt::Quick
        Qt::QuickPrivate
        gammaray_kitemmodels
    )

    if(TARGET Qt::Gui_GLESv2)
        include(CheckCXXSourceCompiles)
        list(APPEND CMAKE_REQUIRED_LIBRARIES Qt::Gui_GLESv2)
        check_cxx_source_compiles("int main() {return 0;}" CAN_LINK_GUI_GLESV2)
        if(CAN_LINK_GUI_GLESV2)
            set(HAVE_GLESv2 TRUE)
            target_link_libraries(gammaray_quickinspector Qt::Gui_GLESv2)
        endif()
    endif()

    #the Qt::Gui_GLESv2 target is not set on Android (up to qt5.13, at least)
    if(ANDROID AND NOT TARGET Qt::Gui_GLESv2)
        target_link_libraries(gammaray_quickinspector GLESv2)
    endif()
endif()

if(GAMMARAY_BUILD_UI)
    # ui plugin
    set(gammaray_quickinspector_ui_srcs
        gridsettingswidget.cpp
        gridsettingswidget.h
        materialextension/materialextensionclient.cpp
        materialextension/materialextensionclient.h
        materialextension/materialtab.cpp
        materialextension/materialtab.h
        quickclientitemmodel.cpp
        quickclientitemmodel.h
        quickinspectorclient.cpp
        quickinspectorclient.h
        quickinspectorwidget.cpp
        quickinspectorwidget.h
        quickitemdelegate.cpp
        quickitemdelegate.h
        quickitemtreewatcher.cpp
        quickitemtreewatcher.h
        quickoverlaylegend.cpp
        quickoverlaylegend.h
        quickscenecontrolwidget.cpp
        quickscenecontrolwidget.h
        quickscenepreviewwidget.cpp
        quickscenepreviewwidget.h
        textureextension/texturetab.cpp
        textureextension/texturetab.h
        textureextension/textureviewwidget.cpp
        textureextension/textureviewwidget.h
        textureextension/resources.qrc
    )

    if(NOT QT_NO_OPENGL)
        list(
            APPEND
            gammaray_quickinspector_ui_srcs
            geometryextension/sggeometrytab.cpp
            geometryextension/sggeometrytab.h
            geometryextension/sgwireframewidget.cpp
            geometryextension/sgwireframewidget.h
        )
    endif()

    gammaray_add_plugin(
        gammaray_quickinspector_ui
        JSON
        gammaray_quickinspector.json
        SOURCES
        ${gammaray_quickinspector_ui_srcs}
    )

    target_link_libraries(gammaray_quickinspector_ui gammaray_quickinspector_shared gammaray_ui Qt::Quick)

endif()

=== plugins/scriptenginedebugger/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe plugin
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_scriptenginedebugger_plugin_srcs scriptenginedebugger.cpp)

    gammaray_add_plugin(
        gammaray_scriptenginedebugger_plugin
        JSON
        gammaray_scriptenginedebugger.json
        SOURCES
        ${gammaray_scriptenginedebugger_plugin_srcs}
    )

    target_link_libraries(gammaray_scriptenginedebugger_plugin Qt5::Script Qt5::ScriptTools gammaray_core)
    set_target_properties(gammaray_scriptenginedebugger_plugin PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)
endif()

# UI plugin
if(GAMMARAY_BUILD_UI)
    set(gammaray_scriptenginedebugger_ui_plugin_srcs scriptenginedebuggerwidget.cpp)

    gammaray_add_plugin(
        gammaray_scriptenginedebugger_ui_plugin
        JSON
        gammaray_scriptenginedebugger.json
        SOURCES
        ${gammaray_scriptenginedebugger_ui_plugin_srcs}
    )

    target_link_libraries(gammaray_scriptenginedebugger_ui_plugin Qt5::Script Qt5::ScriptTools gammaray_ui)
endif()

=== plugins/statemachineviewer/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# shared part
set(gammaray_statemachineviewer_shared_srcs statemachineviewerinterface.cpp)

# probe part
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_statemachineviewer_plugin_srcs
        qsmstatemachinedebuginterface.cpp
        qsmstatemachinedebuginterface.h
        statemachinedebuginterface.cpp
        statemachinedebuginterface.h
        statemachineviewerserver.cpp
        statemachineviewerserver.h
        statemachinewatcher.cpp
        statemachinewatcher.h
        statemodel.cpp
        statemodel.h
        transitionmodel.cpp
        transitionmodel.h
    )

    if(TARGET Qt::Scxml)
        list(APPEND gammaray_statemachineviewer_plugin_srcs qscxmlstatemachinedebuginterface.cpp
             qscxmlstatemachinedebuginterface.h
        )
    endif()

    gammaray_add_plugin(
        gammaray_statemachineviewer_plugin
        JSON
        gammaray_statemachineviewer.json
        SOURCES
        ${gammaray_statemachineviewer_plugin_srcs}
        ${gammaray_statemachineviewer_shared_srcs}
    )

    set_target_properties(gammaray_statemachineviewer_plugin PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)

    target_link_libraries(gammaray_statemachineviewer_plugin gammaray_core)

    if(TARGET Qt::Scxml)
        target_link_libraries(gammaray_statemachineviewer_plugin Qt::Scxml Qt::ScxmlPrivate)
    endif()
    if(${QT_VERSION_MAJOR} EQUAL 6 AND TARGET Qt6::StateMachine)
        target_link_libraries(gammaray_statemachineviewer_plugin Qt6::StateMachine Qt6::StateMachinePrivate)
    endif()
endif()

# UI part
if(GAMMARAY_BUILD_UI AND GAMMARAY_WITH_KDSME)

    set(gammaray_statemachineviewer_ui_plugin_srcs
        statemachineviewerclient.cpp
        statemachineviewerclient.h
        statemachineviewerwidget.cpp
        statemachineviewerwidget.h
        statemodeldelegate.cpp
        statemodeldelegate.h
    )

    gammaray_add_plugin(
        gammaray_statemachineviewer_ui_plugin
        JSON
        gammaray_statemachineviewer.json
        SOURCES
        ${gammaray_statemachineviewer_ui_plugin_srcs}
        ${gammaray_statemachineviewer_shared_srcs}
    )

    target_link_libraries(
        gammaray_statemachineviewer_ui_plugin
        KDSME::Core
        KDSME::View
        gammaray_common
        gammaray_ui
    )

    if(${QT_VERSION_MAJOR} EQUAL 6 AND TARGET Qt6::StateMachine)
        target_link_libraries(gammaray_statemachineviewer_ui_plugin Qt6::StateMachine)
    endif()
endif()

=== plugins/webinspector/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe part
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_webinspector_plugin_srcs webinspector.cpp webinspector.h webviewmodel.cpp webviewmodel.h)

    gammaray_add_plugin(
        gammaray_webinspector_plugin
        JSON
        gammaray_webinspector.json
        SOURCES
        ${gammaray_webinspector_plugin_srcs}
    )

    target_link_libraries(gammaray_webinspector_plugin gammaray_core)

    set_target_properties(gammaray_webinspector_plugin PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)
endif()

# ui part
if(GAMMARAY_BUILD_UI AND TARGET Qt::WebEngineWidgets)
    set(gammaray_webinspector_ui_plugin_srcs webinspectorwidget.cpp webinspectorwidget.h)

    gammaray_add_plugin(
        gammaray_webinspector_ui_plugin
        JSON
        gammaray_webinspector.json
        SOURCES
        ${gammaray_webinspector_ui_plugin_srcs}
    )

    target_link_libraries(gammaray_webinspector_ui_plugin Qt::WebEngineWidgets gammaray_ui)
endif()

=== debian/changelog ===
gammaray (3.1.0+ds-3ubuntu4) questing; urgency=medium

  * d/patches: Add upstream_fix-gammray-build-Qt-6.9.patch
    https://github.com/KDAB/GammaRay/commit/73a102f5
  * Make flaky tests non fatal.
  * Fix build with GCS on arm64.

 -- Rik Mills <rikmills@kde.org>  Thu, 18 Sep 2025 11:12:30 +0100

gammaray (3.1.0+ds-3ubuntu3) questing; urgency=medium

  * d/patches: Add upstream_fix-gammray-build-Qt-6.9.patch
    https://github.com/KDAB/GammaRay/commit/73a102f5

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 13:43:16 +0100

gammaray (3.1.0+ds-3ubuntu2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 06:29:20 +0100

gammaray (3.1.0+ds-3ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining chanages:
    - Disable LauncherTest and ClientConnectionTest that fail on Ubuntu
      because of ptrace protection.

 -- Rik Mills <rikmills@kde.org>  Thu, 22 May 2025 11:08:00 +0100

gammaray (3.1.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Make it possible to build on non-Linux architectures:
    - limit the libwayland-dev, qt6-connectivity-dev, qt6-wayland, and
      qt6-wayland-dev build dependencies as linux-any
    - limit the gammaray-plugin-waylandinspector, and gammaray-plugin-bluetooth
      binary packages as linux-any
  * Remove the unneeded libproj-dev build dependency. (Closes: #1050765)
  * Simplify debian-archs-fix-build.patch for GNU/Hurd: accept the x86 string
    with the AT386 suffix as i686.
  * Add the configuration for the CI on salsa.
  * Bump Standards-Version to 4.7.2, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 05 Apr 2025 10:56:31 +0200

gammaray (3.1.0+ds-2ubuntu3) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:12:42 -0500

gammaray (3.1.0+ds-2ubuntu2) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.2.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 05 Feb 2025 03:39:30 -0600

gammaray (3.1.0+ds-2ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable, remaining change:
    - Disable LauncherTest and ClientConnectionTest that fail on Ubuntu
      because of ptrace protection.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 12 Jan 2025 21:27:39 +0300

gammaray (3.1.0+ds-2) unstable; urgency=medium

  * Team upload.

  [ Dmitry Shachnev ]
  * Drop disable-qmllint.patch. Instead, add qml6-module-qtquick-templates
    to build-dependencies; this makes qmllint not crash.

  [ Santiago Vila ]
  * Disable flaky tests. Closes: #1017144.

 -- Dmitry Shachnev <mitya57@debian.org>  Mon, 23 Sep 2024 13:00:22 +0300

gammaray (3.1.0+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Repack upstream tarball to exclude bundled copy of graphviz.
    This reduces the tarball size from 60 MB to 11 MB.
  * Refresh patches for the new release.
  * Update debian/copyright.
  * Export LC_ALL=C.UTF-8 in debian/rules.
  * Build-depend on qml6-module-qtquick-{controls,window}.
  * Add a patch to not run qmllint on quick-event-handling.qml.
  * Stop installing gammaray_qtivi_ui.so.
  * Upload to unstable.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 22 Sep 2024 20:11:18 +0300

gammaray (3.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update Build-Depends and Depends from Qt 5 to Qt 6.
  * Remove "export QT_SELECT=5" from debian/rules.
  * Drop increase-test-timeout.patch, applied upstream.
  * Refresh and rebase other patches.
    - Drop GNU/kFreeBSD support from debian-archs-fix-build.patch.
  * Update install files for switch to Qt 6.
  * Disable plugins which are not available:
    - codecbrowser, statemachineviewer, scriptenginedebugger (Qt 5 only).
    - objectvisualizer (removed in the new release).
  * Install the new openglsupport plugin.
  * Update debian/copyright.
  * Update the command to remove licenses from /usr/share/doc/gammaray.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Sat, 15 Jun 2024 23:04:21 +0300

gammaray (2.11.3-4) unstable; urgency=medium

  * Team upload.
  * Stop depending on qtwebengine5-dev on mipsel (closes: #1041265).

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 16 Jul 2023 19:33:07 +0300

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gdb,
               glslang-tools,
               libgraphviz-dev,
               libkf6coreaddons-dev,
               libkf6syntaxhighlighting-dev,
               libwayland-dev (>= 1.12.0) [linux-any],
               qml6-module-qtqml,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick,
               qml6-module-qtquick-controls,
               qml6-module-qtquick-templates,
               qml6-module-qtquick-window,
               qt6-3d-assimpsceneimport-plugin,
               qt6-3d-defaultgeometryloader-plugin,
               qt6-3d-dev,
               qt6-3d-gltfsceneio-plugin,
               qt6-3d-scene2d-plugin,
               qt6-base-private-dev,
               qt6-connectivity-dev [linux-any],
               qt6-declarative-dev,
               qt6-declarative-dev-tools,
               qt6-declarative-private-dev,
               qt6-location-dev,
               qt6-positioning-dev,
               qt6-shadertools-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools,
               qt6-translations-l10n,
               qt6-wayland [linux-any],
               qt6-wayland-dev [linux-any],
               qt6-webengine-dev [amd64 arm64 armhf i386],
               xauth,
               xvfb
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gammaray.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gammaray
Homepage: https://www.kdab.com/development-resources/qt-tools/gammaray/

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: qml6-module-qtquick-controls,
         qml6-module-qtquick-scene3d,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-plugin-quickinspector
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: GammaRay plugin for inspecting QtQuick2 applications
 This plugin provides the user with the following inspection and debugging
 facilities:
 .
  * Tree view of all QQuickItems in the scene, marking invisible items
    and items having focus.
  * Object inspector allowing to see all the properties, inspect
    signal-slot connections, and directly invoke slots and Q_INVOKABLE
    methods.
  * Live-preview of the QtQuick scene inside the GammaRay window.
  * Qt Quick scene graph inspector.

Package: gammaray-plugin-waylandinspector
Architecture: linux-any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: Wayland compositor inspector plugin for GammaRay
 The Wayland compositor inspector allows one to browse QWaylandClient
 instances and their associated resources, as well as observe Wayland
 events.

Package: gammaray-plugin-kjobtracker
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: KJob tracker plugin for GammaRay
 This plugin can be used to monitor KJob instances within a KDE-based
 application.

Package: gammaray-plugin-bluetooth
Architecture: linux-any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: QtBluetooth type support for GammaRay
 This plugin adds support for QtBluetooth types into GammaRay.

Package: gammaray-plugin-positioning
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml6-module-qtlocation,
         qml6-module-qtpositioning,
         qml6-module-qtquick,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: Qt6Positioning type support for GammaRay
 This plugin adds support for Qt6Positioning types into GammaRay.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}), ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_test override_dh_auto_install override_dh_installdocs

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Give the build more time to finish the test suite.
# Timeouts have been appearing on buildd machines for some architectures.
export GAMMARAY_LAUNCHER_TIMEOUT=240

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DQT_MAJOR_VERSION=6 -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=FALSE

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 i386))
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
# attachtest-gdb is unstable on s390x and hangs builds
else ifeq ($(DEB_HOST_ARCH), s390x)
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V -E attachtest-gdb"
else
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
endif

override_dh_auto_install:
	dh_auto_install
	# We have /usr/share/doc/gammaray/copyright which references licenses
	# in /usr/share/common-licenses, so these files are redundant.
	rm -v debian/tmp/usr/share/doc/gammaray/LICENSE.txt
	rm -rfv debian/tmp/usr/share/doc/gammaray/LICENSES

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

=== debian/watch ===
version=4
opts=searchmode=plain,pgpsigurlmangle=s/$/.asc/,dversionmangle=auto,repacksuffix=+ds \
https://api.github.com/repos/KDAB/GammaRay/releases \
https://github.com/KDAB/GammaRay/releases/download/v[\d.]+/gammaray-([\d.]+)\.tar\.gz
